#define clamp(v,l,h) min(max(v,l),h)
var/alive_units=0

proc
	true_loc_x(var/atom/movable/A)
		return A.loc.x*32+A.step_x

	true_loc_y(var/atom/movable/A)
		return A.loc.y*32+A.step_y

	distance_to(var/atom/movable/mob_a,var/atom/movable/mob_b)
		var ax=mob_a.loc.x*32+mob_a.step_x
		var ay=mob_a.loc.y*32+mob_a.step_y
		var bx=mob_b.loc.x*32+mob_b.step_x
		var by=mob_b.loc.y*32+mob_b.step_y
		//	world << "[ax] [ay] [bx] [by] [sqrt((ax-bx)**2+(ay-by)**2)] [((ax-bx)**2+(ay-by)**2)]"
		return sqrt((ax-bx)**2+(ay-by)**2)

mob
	unit
		density=1
		layer=4
		step_size=5
		New()
			..()
			alive_units++
		Del()
			alive_units--
			..()
		var
			team="A"
			hp=100
			target=null
			attack_cd=0
			timer=0
			nav=EAST
			phase="navigation"
			turf/stored_loc=null
			stored_sx=0
			stored_sy=0
		proc
			experiment()
				stored_loc=loc
				stored_sx=step_x
				stored_sy=step_y
				loc=null
			custom_move()

				var global_px=loc.x*icon_size+step_x
				var global_py=loc.y*icon_size+step_y



				global_px+=vel_x
				global_py+=vel_y

				global_px=clamp(global_px,icon_size,world.maxx*icon_size-icon_size)
				global_py=clamp(global_py,icon_size,world.maxy*icon_size-icon_size)


				var new_loc = locate(global_px/icon_size, global_py/icon_size,z)
				var new_sx = global_px%icon_size
				var new_sy = global_py%icon_size
				loc=new_loc
				step_x=new_sx
				step_y=new_sy



			physics_NPC()
				if(src.n==1)
					n()
				else if(s==1)
					s()
				if(e==1)
					e()
				else if(w==1)
					w()
				if(src.vel_x<0)
				//	src.step_size=(-vel_x)
					vel_x+=1
					if(vel_x<-move_speed)
						vel_x+=2
					//translate(
					//Move(atom/NewLoc,Dir=0,Step_x=0,Step_y=0)

					//Translate(-32,0,WEST)
				else if(src.vel_x>0)
					//src.step_size=vel_x
					vel_x-=1
					if(vel_x>move_speed)
						vel_x-=2

					//Translate(320,320)
				if(src.vel_y<0)
				//	src.step_size=(-vel_y)
					vel_y+=1
					if(vel_y<-move_speed)
						vel_y+=2

					//Translate(0,10,SOUTH)
				else if(src.vel_y>0)
				//	src.step_size=(vel_y)
					vel_y-=1
					if(vel_y>move_speed)
						vel_y-=2






	/*			//if(
				var/mob/unit/M
				for(M in bounds())
					M.step_size=get_dir(src,M)
					M.move_away_from(src)
				if(src.n==1)
					n()
				else if(s==1)
					s()
				if(e==1)
					e()
				else if(w==1)
					w()
				var/D=dir
				if(src.vel_x<0)
					src.step_size=(-vel_x)
					vel_x+=1
					if(vel_x<-move_speed)
						vel_x+=2
					//translate(
					//Move(atom/NewLoc,Dir=0,Step_x=0,Step_y=0)
					step(src,WEST)
					//Translate(-32,0,WEST)
				else if(src.vel_x>0)
					src.step_size=vel_x
					vel_x-=1
					if(vel_x>move_speed)
						vel_x-=2
					step(src,EAST)
					//Translate(320,320)
				if(src.vel_y<0)
					src.step_size=(-vel_y)
					vel_y+=1
					if(vel_y<-move_speed)
						vel_y+=2
					step(src,SOUTH)
					//Translate(0,10,SOUTH)
				else if(src.vel_y>0)
					src.step_size=(vel_y)
					vel_y-=1
					if(vel_y>move_speed)
						vel_y-=2
					step(src,NORTH)
					//Translate(0,10,NORTH)
				src.dir=D
			//	src.spawn_body()
				..()
				*/
			damage(var/amount)
				hp-=amount
				if(hp<=0)
				//	src.spawn_body()
					var/mob/M=src
					spawn(0)
						new/obj/temp_obj/body(null,M)
//					body_test(src)
					spawn(0.5)
						del M
			attack(var/mob/unit/M)
				if(attack_cd)return 0
				flick("attack",src)

				M.damage(rand(15,25))
				src.attack_cd=1
				spawn(5)
					if(src)
						attack_cd=0

			unit_AI()
				flick("spawn",src)
				loop
					timer++
					switch(phase)
						if("combat")
							if(timer>1)
						//		decision_loop()
								duel_enemy()
						if("navigation")
							if(timer>5)
								decision_loop()
							nav_loop()
			//		physics_NPC()



					spawn(0.2)goto loop
			nav_loop()
				switch(src.nav)
					if(NORTH)n()
					if(WEST)w()
					if(SOUTH)s()
					if(EAST)e()
			decision_loop()
				var a=detect_nearby_enemies()
				if(a)
					phase="combat"
					target=a
					var/mob/unit/M=a
					M.target=src
					nav=convert_direction(get_dir(M.loc,src.loc))
				else
					phase="navigation"
					if(team=="A")nav=EAST
					else nav=WEST
				timer=0
			convert_direction(thing)
				switch(thing)
					if(NORTHEAST)return EAST
					if(NORTHWEST)return WEST
					if(SOUTHWEST)return WEST
					if(SOUTHEAST)return EAST
				return thing
			detect_nearby_enemies()
				for(var/mob/unit/U in orange(2,src))//bounds(src,0,0,64,64))
					if(U.team!=src.team)
						return U
				return FALSE




			duel_enemy()
				if(!target)
					phase="navigation"
					return
				move_towards(target)
				if(distance_to(src,target)<55)
					attack(target)
			spread_out()
				for(var/mob/unit/U in bounds(src))
					if(U==src||U.team!=src.team)
						continue
					if(distance_to(src,U)<14)
						move_away_from(U)
						return 1
				return 0
			move_towards_enemies()
				for(var/mob/unit/U in range(1,src))
					if(U==src||U.team==src.team)
						continue
					else
						target=U
						return 1
				return 0
			move_away_from(var/mob/M)
				var d=get_dir(M.loc,src.loc)
				switch(d)
					if(NORTH)n()
					if(WEST)w()
					if(SOUTH)s()
					if(EAST)e()
					if(NORTHEAST)e()
					if(NORTHWEST)w()
					if(SOUTHWEST)w()
					if(SOUTHEAST)e()
					else
					//	world << "ELSE [d]"
						var x=pick(1,2,3,4)
						switch(x)
							if(1)s()
							if(2)n()
							if(3)e()
							if(4)w()
			move_towards(var/atom/M)
				var d=get_dir(src.loc,M.loc)
				switch(d)
					if(NORTH)n()
					if(WEST)w()
					if(SOUTH)s()
					if(EAST)e()
					if(NORTHEAST)e()
					if(NORTHWEST)w()
					if(SOUTHWEST)w()
					if(SOUTHEAST)e()
					else
					//	world << "ELSE t [d]"
						var x=pick(1,2,3,4)
						switch(x)
							if(1)s()
							if(2)n()
							if(3)e()
							if(4)w()

			walk_towards_nexus()
			//	world << "AAA"
				if(team=="A")
					move_towards(nexus_b)//step(src,EAST)
				else
					move_towards(nexus_a)//step(src,WEST)
		conscript
			icon='temp_soldier.dmi'
			icon_state=""
			density=0
			pixel_x=-12
			bound_width=6
			bound_height=6
			New()
				..()
				active_mobs+=src
				spawn(1)flick("attack",src)
				spawn(5)unit_AI()

/*	proc
		n()
			if(!can_move)return
			if(vel_y<move_speed)vel_y+=2
	//		src.dir=NORTH
		s()
			if(!can_move)return
			if(vel_y>-move_speed)vel_y-=2
	//		src.dir=SOUTH
		w()
			if(!can_move)return
			if(vel_x>-move_speed)vel_x-=2
			src.dir=WEST
		e()
			if(!can_move)return
			if(vel_x<move_speed)vel_x+=2
			src.dir=EAST*/